From 459c740e994f8ef187f0f456779efb5631e49607 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 724/1001] Convert the meetings widget


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
old mode 100755
new mode 100644
index d91d452..7b5129a
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -29,6 +29,7 @@ def add_user_widgets(session, hub, username, fullname):
         plugin='meetings', index=-1,
         _config=json.dumps({
             'calendar': 'Fedora release',
+            'n_meetings': 4,
         }))
     hub.widgets.append(widget)
 
diff --git a/hubs/tests/test_widgets/test_meetings.py b/hubs/tests/test_widgets/test_meetings.py
index 08ea046..859bfb9 100644
--- a/hubs/tests/test_widgets/test_meetings.py
+++ b/hubs/tests/test_widgets/test_meetings.py
@@ -20,7 +20,8 @@ class TestMeetings(hubs.tests.test_widgets.WidgetTest):
     def test_render_simple(self):
         team = 'i18n'
         widget = self.widget_instance(team, self.plugin)
-        response = self.app.get('/%s/%i/' % (team, widget.idx))
+        response = self.app.get('/%s/w/%s/%i/'
+                                % (team, self.plugin, widget.idx))
         self.assertEqual(200, response.status_code)
         self.assertIn('i18n', response.get_data(as_text=True))
         self.assertIn('<strong>Request A New Meeting</strong>',
diff --git a/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_meetings.TestMeetings.test_render_simple b/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_meetings.TestMeetings.test_render_simple
new file mode 100644
index 0000000..32812c9
--- /dev/null
+++ b/hubs/tests/vcr-request-data/hubs.tests.test_widgets.test_meetings.TestMeetings.test_render_simple
@@ -0,0 +1,43 @@
+interactions:
+- request:
+    body: null
+    headers:
+      Accept: ['*/*']
+      Accept-Encoding: ['gzip, deflate']
+      Connection: [keep-alive]
+      User-Agent: [python-requests/2.12.5]
+    method: GET
+    uri: https://apps.fedoraproject.org/calendar/api/meetings/?calendar=i18n
+  response:
+    body:
+      string: !!binary |
+        H4sIAAAAAAAAA+3Zz2/bIBQH8H/lyadNCrZx82s5Teuph/bUSanWKWL2S8pqQ4RJqy3K/z7I0ogw
+        7TBp8rsgxYcA5svDH3Gw91mHaKXa9NkCvuzf/q2s7HDVW2Gsa8/K6aIs3S8bwXmEbFzPhE+qsE2t
+        temElVr52z5J9or43P6A0wBw3SD5XIHBVlhsoJF9vet7d0OfP5pH5a9bbRCCqUC8CNmKby2CsAt4
+        snbbL4pijY02Ymv0d6xtrs2meJXPsrjh87vi9lRUUZV8zJZL9vAAAO+WS2DQaWWfRuBaGDRuEfl7
+        X1YtWlSNMCslOvSL98sM6z3tiN4eN2T254b4uVZuDt/vYmes5KwchyNaXZ/35vfq2anrozR1vjaI
+        SjeYK7ThbZ1QYoPGP6Bsa8SLVH32NQr+e2hYz9tziOv6qdVxzOf76+wwgsTgPzPgcwIGl6GJATWD
+        yj2UwRnEoYkBPQM+IWBwGZoYUDO4ojgN4tDEgJ4BwWkQhyYG9AyqDwQMLkMTA2oGY8arwRnEoYkB
+        PYNqSsDgMjQxoGYwYbwcnEEcmhjQM6iGf4sYhyYG1AymrJwNziAOTQzoGVTDvzeIQxMDagb+iB6c
+        QRyaGNAz4MO/N4hD/5mBn1qYza5DZf135312dnD+hlmFWxbuVlT/1fFgCupWu7Y9HH4Bm4DFHNge
+        AAA=
+    headers:
+      Accept-Ranges: [bytes]
+      Age: ['0']
+      AppServer: [proxy04.fedoraproject.org]
+      AppTime: [D=176951]
+      Connection: [Keep-Alive]
+      Content-Encoding: [gzip]
+      Content-Length: ['515']
+      Content-Type: [application/json]
+      Date: ['Wed, 01 Feb 2017 08:36:43 GMT']
+      Keep-Alive: ['timeout=15, max=500']
+      Server: [Apache/2.4.6 (Red Hat Enterprise Linux) mod_wsgi/3.4 Python/2.7.5]
+      Set-Cookie: ['fedocal=eyJfcGVybWFuZW50Ijp0cnVlfQ.C3Mvmw.rzQ95C3LVBlZJKMEJVpzih4SIT4;
+          Expires=Wed, 01-Feb-2017 09:36:43 GMT; Secure; HttpOnly; Path=/calendar']
+      Strict-Transport-Security: [max-age=15768000; includeSubDomains; preload]
+      Vary: [Accept-Encoding]
+      Via: [1.1 varnish-v4]
+      X-Varnish: ['1754049']
+    status: {code: 200, message: OK}
+version: 1
diff --git a/hubs/widgets/meetings/__init__.py b/hubs/widgets/meetings/__init__.py
new file mode 100644
index 0000000..9209de2
--- /dev/null
+++ b/hubs/widgets/meetings/__init__.py
@@ -0,0 +1,135 @@
+from __future__ import unicode_literals
+
+import arrow
+import collections
+import datetime
+import requests
+
+from hubs import validators
+from hubs import utils
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+
+
+class Meetings(Widget):
+
+    name = "meetings"
+    position = "both"
+    arguments = [
+        dict(
+            name="calendar",
+            label="Calendar",
+            default=None,
+            validator=validators.required,
+            help="A fedocal calendar.",
+        ), dict(
+            name="n_meetings",
+            label="Number of meetings",
+            default=4,
+            validator=validators.integer,
+            help="The number of meetings to display.",
+        )]
+
+    def get_template_environment(self):
+        env = super(Meetings, self).get_template_environment()
+        # Add a filter
+        env.filters['humanize'] = lambda d: arrow.get(d).humanize()
+        return env
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/meetings.html"
+    chrome = panel(title='Meetings', footer_template='templates/meeting_footer.html')
+
+    def get_context(self, instance, *args, **kwargs):
+        get_meetings = GetMeetings(instance)
+        return dict(
+            calendar=instance.config["calendar"],
+            meetings=get_meetings(),
+            )
+
+
+class GetMeetings(CachedFunction):
+
+    def execute(self):
+        calendar = self.instance.config["calendar"]
+        n_meetings = int(self.instance.config.get("n_meetings", 4))
+        base = ('https://apps.fedoraproject.org/calendar/api/meetings/'
+                '?calendar=%s')
+        url = base % calendar
+        response = requests.get(url).json()
+
+        tmp = collections.defaultdict(list)
+        for meeting in response['meetings']:
+            if meeting.get('meeting_information_html'):
+                meeting['meeting_information_html'] = utils.markup(
+                    meeting['meeting_information'])
+            tmp[meeting['meeting_name']].append(meeting)
+
+        meetings = {}
+        for title, items in tmp.items():
+            selected = next_meeting(items)
+            if not selected:
+                continue
+            meetings[title] = selected
+            if len(meetings) >= n_meetings:
+                break
+
+        return meetings
+
+    def should_invalidate(self, message):
+        # TODO -- first, if this is a fedocal widget, we need to just
+        # invalidate ourselves right away.
+
+        # second, check our old cache value and see if any of our meetings have
+        # passed by in time.
+        old_meetings = self.execute()
+        now = datetime.datetime.utcnow()
+        for title, meeting in old_meetings.items():
+            assert type(meeting['start_dt']) == type(now)
+            if meeting['start_dt'] < now:
+                return True
+        return False
+
+
+def next_meeting(meetings):
+    now = datetime.datetime.utcnow()
+    for meeting in meetings:
+        start_string = "%s %s" % (
+            meeting['meeting_date'], meeting['meeting_time_start'])
+        start_dt = datetime.datetime.strptime(
+            start_string, "%Y-%m-%d %H:%M:%S")
+
+        stop_string = "%s %s" % (
+            meeting['meeting_date_end'], meeting['meeting_time_stop'])
+        stop_dt = datetime.datetime.strptime(
+            stop_string, "%Y-%m-%d %H:%M:%S")
+
+        # Loop over them until we find a good one.
+        # Meetings before now are no good.  We want the first one after now.
+        if start_dt < now:
+            continue
+
+        meeting['start_dt'] = start_dt
+        meeting['start_date'] = start_dt.strftime('%b %d')
+        meeting['stop_date'] = stop_dt.strftime('%b %d')
+        meeting['display_time'] = True
+        meeting['display_duration'] = False
+        # Just UTC for now until we do this on the client and can access
+        # their local with moment.js.
+        meeting['start_time'] = meeting['meeting_time_start'][:-3] + " UTC"
+        meeting['stop_time'] = meeting['meeting_time_stop'][:-3] + " UTC"
+        meeting['location'] = meeting['meeting_location'] or ''
+        if '@' in meeting['location']:
+            meeting['location'] = '#' + meeting['location'].split('@')[0]
+        if stop_dt - start_dt >= datetime.timedelta(hours=24):
+            meeting['display_time'] = False
+            if stop_dt - start_dt > datetime.timedelta(hours=24):
+                meeting['display_duration'] = True
+        return meeting
+
+    return None
diff --git a/populate.py b/populate.py
index 503b0e9..3eab11d 100755
--- a/populate.py
+++ b/populate.py
@@ -99,7 +99,7 @@ widget = hubs.models.Widget(plugin='rules', index=1,
 hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'commops'}))
+                            _config=json.dumps({'calendar': 'commops', 'n_meetings': 4}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -146,7 +146,7 @@ widget = hubs.models.Widget(plugin='rules', index=1,
 hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'marketing'}))
+                            _config=json.dumps({'calendar': 'marketing', 'n_meetings': 4}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -194,7 +194,7 @@ widget = hubs.models.Widget(plugin='rules', index=1,
 hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'design'}))
+                            _config=json.dumps({'calendar': 'design', 'n_meetings': 4}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget
@@ -243,7 +243,7 @@ widget = hubs.models.Widget(plugin='rules', index=1,
 hub.widgets.append(widget)
 
 widget = hubs.models.Widget(plugin='meetings', index=2,
-                            _config=json.dumps({'calendar': 'infrastructure'}))
+                            _config=json.dumps({'calendar': 'infrastructure', 'n_meetings': 4}))
 hub.widgets.append(widget)
 
 # Added a hubs about widget

